<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPacketTemperature ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPacketTemperature
 * @subpackage Arrays
 */
class ArrayOfPacketTemperature extends AbstractStructArrayBase
{
    /**
     * The PacketTemperature
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PacketTemperature[]
     */
    public $PacketTemperature;
    /**
     * Constructor method for ArrayOfPacketTemperature
     * @uses ArrayOfPacketTemperature::setPacketTemperature()
     * @param \StructType\PacketTemperature[] $packetTemperature
     */
    public function __construct(array $packetTemperature = array())
    {
        $this
            ->setPacketTemperature($packetTemperature);
    }
    /**
     * Get PacketTemperature value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PacketTemperature[]|null
     */
    public function getPacketTemperature()
    {
        return isset($this->PacketTemperature) ? $this->PacketTemperature : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPacketTemperature method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPacketTemperature method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePacketTemperatureForArrayConstraintsFromSetPacketTemperature(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPacketTemperaturePacketTemperatureItem) {
            // validation for constraint: itemType
            if (!$arrayOfPacketTemperaturePacketTemperatureItem instanceof \StructType\PacketTemperature) {
                $invalidValues[] = is_object($arrayOfPacketTemperaturePacketTemperatureItem) ? get_class($arrayOfPacketTemperaturePacketTemperatureItem) : sprintf('%s(%s)', gettype($arrayOfPacketTemperaturePacketTemperatureItem), var_export($arrayOfPacketTemperaturePacketTemperatureItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PacketTemperature property can only contain items of type \StructType\PacketTemperature, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PacketTemperature value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PacketTemperature[] $packetTemperature
     * @return \ArrayType\ArrayOfPacketTemperature
     */
    public function setPacketTemperature(array $packetTemperature = array())
    {
        // validation for constraint: array
        if ('' !== ($packetTemperatureArrayErrorMessage = self::validatePacketTemperatureForArrayConstraintsFromSetPacketTemperature($packetTemperature))) {
            throw new \InvalidArgumentException($packetTemperatureArrayErrorMessage, __LINE__);
        }
        if (is_null($packetTemperature) || (is_array($packetTemperature) && empty($packetTemperature))) {
            unset($this->PacketTemperature);
        } else {
            $this->PacketTemperature = $packetTemperature;
        }
        return $this;
    }
    /**
     * Add item to PacketTemperature value
     * @throws \InvalidArgumentException
     * @param \StructType\PacketTemperature $item
     * @return \ArrayType\ArrayOfPacketTemperature
     */
    public function addToPacketTemperature(\StructType\PacketTemperature $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PacketTemperature) {
            throw new \InvalidArgumentException(sprintf('The PacketTemperature property can only contain items of type \StructType\PacketTemperature, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PacketTemperature[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PacketTemperature|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PacketTemperature|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PacketTemperature|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PacketTemperature|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PacketTemperature|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PacketTemperature
     */
    public function getAttributeName()
    {
        return 'PacketTemperature';
    }
}
